"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var Bluebird = require("bluebird");
var buffer_1 = require("buffer");
var crypto_1 = require("crypto");
var fs_1 = require("fs");
var stream_1 = require("stream");
var child_process_1 = require("child_process");
var nigel_1 = require("nigel");
var logger_1 = require("./logger");
var util_1 = require("./util");
var isBsd = Boolean(~process.platform.indexOf('bsd'));
var make = util_1.isWindows ? 'vcbuild.bat' : isBsd ? 'gmake' : 'make';
var configure = util_1.isWindows ? 'configure' : './configure';
var marker = buffer_1.Buffer.from('<nexe~sentinel>').toString('hex');
var tail = "\n//" + marker;
var needle = buffer_1.Buffer.from(marker);
var fixedIntegerLength = 10;
var padLeft = function (x, l, c) {
    if (l === void 0) { l = fixedIntegerLength; }
    if (c === void 0) { c = '0'; }
    return (c.repeat(l) + x).slice(-l);
};
var inflate = function (value, size) {
    if (!size || value.length >= size) {
        return value;
    }
    return value + ' '.repeat(size - value.length);
};
var NexeCompiler = (function () {
    function NexeCompiler(options) {
        var _this = this;
        this.options = options;
        this.start = Date.now();
        this.env = __assign({}, process.env);
        this.log = new logger_1.Logger(this.options.loglevel);
        this.src = path_1.join(this.options.temp, this.options.version);
        this.files = [];
        this.resources = {
            index: {},
            bundle: ''
        };
        this.nodeSrcBinPath = util_1.isWindows
            ? path_1.join(this.src, 'Release', 'node.exe')
            : path_1.join(this.src, 'out', 'Release', 'node');
        var python = (this.options = options).python;
        if (python) {
            if (util_1.isWindows) {
                this.env.PATH = '"' + util_1.dequote(path_1.normalize(python)) + '";' + this.env.PATH;
            }
            else {
                this.env.PYTHON = python;
            }
        }
        this.readFileAsync = function (file) { return __awaiter(_this, void 0, void 0, function () {
            var cachedFile, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        cachedFile = this.files.find(function (x) { return path_1.normalize(x.filename) === path_1.normalize(file); });
                        if (!!cachedFile) return [3 /*break*/, 2];
                        _a = {
                            filename: file
                        };
                        return [4 /*yield*/, util_1.readFileAsync(path_1.join(this.src, file), 'utf-8').catch({ code: 'ENOENT' }, function () { return ''; })];
                    case 1:
                        cachedFile = (_a.contents = _b.sent(),
                            _a);
                        this.files.push(cachedFile);
                        _b.label = 2;
                    case 2: return [2 /*return*/, cachedFile];
                }
            });
        }); };
        this.writeFileAsync = function (file, contents) { return util_1.writeFileAsync(path_1.join(_this.src, file), contents); };
        this.replaceInFileAsync = function (file, replace, value) { return __awaiter(_this, void 0, void 0, function () {
            var entry;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.readFileAsync(file)];
                    case 1:
                        entry = _a.sent();
                        entry.contents = entry.contents.replace(replace, value);
                        return [2 /*return*/];
                }
            });
        }); };
        this.setFileContentsAsync = function (file, contents) { return __awaiter(_this, void 0, void 0, function () {
            var entry;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.readFileAsync(file)];
                    case 1:
                        entry = _a.sent();
                        entry.contents = contents;
                        return [2 /*return*/];
                }
            });
        }); };
    }
    NexeCompiler.prototype.quit = function (code) {
        if (code === void 0) { code = 0; }
        var time = Date.now() - this.start;
        this.log.write("Finsihed in " + time / 1000 + "s");
        return this.log.flush().then(function (x) { return process.exit(code); });
    };
    NexeCompiler.prototype._findPaddingSize = function (size, override) {
        if (override === void 0) { override = this.options.padding; }
        if (override === 0) {
            return 0;
        }
        size = override > size ? override : size;
        var padding = [3, 6, 9, 16, 25, 40].map(function (x) { return x * 1e6; }).find(function (p) { return size <= p; });
        if (!padding) {
            throw new Error("No prebuilt target large enough (" + (size / 1024).toFixed(2) + "Mb).\nUse the --build flag and build for the current platform");
        }
        return padding;
    };
    NexeCompiler.prototype._getNodeExecutableLocation = function (target) {
        if (target) {
            return path_1.join(this.options.temp, target);
        }
        return this.nodeSrcBinPath;
    };
    NexeCompiler.prototype._runBuildCommandAsync = function (command, args) {
        var _this = this;
        return new Bluebird(function (resolve, reject) {
            child_process_1.spawn(command, args, {
                cwd: _this.src,
                env: _this.env,
                stdio: 'ignore'
            })
                .once('error', reject)
                .once('close', resolve);
        });
    };
    NexeCompiler.prototype._configureAsync = function () {
        return this._runBuildCommandAsync(this.env.PYTHON || 'python', [
            configure
        ].concat(this.options.configure));
    };
    NexeCompiler.prototype._buildAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var buildOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.compileStep.log("Configuring node build: " + this.options.configure);
                        return [4 /*yield*/, this._configureAsync()];
                    case 1:
                        _a.sent();
                        buildOptions = util_1.isWindows ? this.options.vcBuild : this.options.make;
                        this.compileStep.log("Compiling Node with arguments: " + buildOptions);
                        return [4 /*yield*/, this._runBuildCommandAsync(make, buildOptions)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, fs_1.createReadStream(this._getNodeExecutableLocation())];
                }
            });
        });
    };
    NexeCompiler.prototype._fetchPrebuiltBinaryAsync = function () {
        return this._buildAsync();
    };
    NexeCompiler.prototype._getPayload = function (header) {
        return this._serializeHeader(header) + this.input + '/**' + this.resources.bundle + "**/";
    };
    NexeCompiler.prototype._generateHeader = function () {
        var _this = this;
        var zeros = padLeft(0);
        var version = ['configure', 'vcBuild', 'make'].reduce(function (a, c) {
            return (a += _this.options[c].slice().sort().join());
        }, '') + this.options.enableNodeCli;
        var header = {
            version: padLeft(0, 32),
            resources: this.resources.index,
            contentSize: zeros,
            paddingSize: zeros,
            resourceOffset: zeros,
            binaryOffset: zeros
        };
        var serializedHeader = this._serializeHeader(header);
        header.contentSize = padLeft(buffer_1.Buffer.byteLength(this._getPayload(header)));
        header.paddingSize = padLeft(this._findPaddingSize(+header.contentSize));
        header.resourceOffset = padLeft(buffer_1.Buffer.byteLength(serializedHeader + this.input + '/**'));
        header.version = crypto_1.createHash('md5').update(version + header.paddingSize).digest('hex');
        return header;
    };
    NexeCompiler.prototype._getExistingBinaryHeaderAsync = function (target) {
        return __awaiter(this, void 0, void 0, function () {
            var filename, existingBinary;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        filename = this._getNodeExecutableLocation(target);
                        return [4 /*yield*/, util_1.pathExistsAsync(filename)];
                    case 1:
                        existingBinary = _a.sent();
                        if (existingBinary) {
                            return [2 /*return*/, this._extractHeaderAsync(filename)];
                        }
                        return [2 /*return*/, null];
                }
            });
        });
    };
    NexeCompiler.prototype._extractHeaderAsync = function (path) {
        var binary = fs_1.createReadStream(path);
        var haystack = new nigel_1.Stream(needle);
        var needles = 0;
        var stackCache = [];
        return new Promise(function (resolve, reject) {
            binary
                .on('error', reject)
                .pipe(haystack)
                .on('error', reject)
                .on('close', function () { return reject(new Error("Binary: " + path + " is not compatible with nexe")); })
                .on('haystack', function (x) { return needles && stackCache.push(x); })
                .on('needle', function () {
                if (++needles === 2) {
                    resolve(JSON.parse(buffer_1.Buffer.concat(stackCache).toString()));
                    binary.close();
                    haystack.end();
                }
            });
        });
    };
    NexeCompiler.prototype._serializeHeader = function (header) {
        return "/**" + marker + JSON.stringify(header) + marker + "**/process.__nexe=" + JSON.stringify(header) + ";";
    };
    NexeCompiler.prototype.setMainModule = function (compiler, next) {
        return __awaiter(this, void 0, void 0, function () {
            var header, contents, file;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, next()];
                    case 1:
                        _a.sent();
                        header = compiler._generateHeader();
                        contents = inflate(this._getPayload(header), +header.paddingSize) + tail;
                        return [4 /*yield*/, compiler.readFileAsync('lib/_third_party_main.js')];
                    case 2:
                        file = _a.sent();
                        file.contents += '\n' + contents;
                        return [2 /*return*/];
                }
            });
        });
    };
    NexeCompiler.prototype.compileAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var step, target, prebuiltBinary, header, existingHeader, location;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        step = (this.compileStep = this.log.step('Compiling result'));
                        target = this.options.targets.slice().shift();
                        prebuiltBinary = null;
                        header = this._generateHeader();
                        target = target && target + "-" + header.version.slice(0, 6);
                        step.log("Scanning existing binary...");
                        return [4 /*yield*/, this._getExistingBinaryHeaderAsync(target)];
                    case 1:
                        existingHeader = _a.sent();
                        if (existingHeader && existingHeader.version === header.version) {
                            location = this._getNodeExecutableLocation(target);
                            step.log("Source already built: " + location);
                            prebuiltBinary = fs_1.createReadStream(location);
                        }
                        if (target) {
                            throw new Error('\nNot Implemented, use --build during beta\n');
                            // prebuiltBinary = await this._fetchPrebuiltBinaryAsync(target)
                        }
                        if (!!prebuiltBinary) return [3 /*break*/, 3];
                        return [4 /*yield*/, this._buildAsync()];
                    case 2:
                        prebuiltBinary = _a.sent();
                        step.log('Node binary compiled');
                        _a.label = 3;
                    case 3: return [2 /*return*/, this._assembleDeliverable(header, prebuiltBinary)];
                }
            });
        });
    };
    NexeCompiler.prototype._assembleDeliverable = function (header, binary) {
        var _this = this;
        var haystack = new nigel_1.Stream(buffer_1.Buffer.concat([buffer_1.Buffer.from('/**'), needle]));
        var artifact = new stream_1.Readable({ read: function () { } });
        var needles = 0;
        var currentStackSize = 0;
        binary.pipe(haystack);
        haystack
            .on('close', function () { return artifact.push(null); })
            .on('needle', function () { return ++needles && haystack.needle(needle); })
            .on('haystack', function (x) {
            if (!needles) {
                currentStackSize += x.length;
                artifact.push(x);
            }
            if (needles === 1 && !+header.binaryOffset) {
                header.binaryOffset = padLeft(currentStackSize);
                var content = buffer_1.Buffer.from(inflate(_this._getPayload(header), +header.paddingSize) + tail);
                artifact.push(content);
            }
            if (needles > 2) {
                artifact.push(x);
            }
        });
        return artifact;
    };
    return NexeCompiler;
}());
exports.NexeCompiler = NexeCompiler;
